*
*     EW O(alpha^3) leading correction to \rho
*     
      complex*16 function drho_at2_as1 (alpha,alphas,mz,mw,mh,mtp)
      implicit none!
      real*8 ctw2,stw2,gfermi,xt,dht
      real*8 alpha,alphas,mz,mw,mh,mtp
      real*8 c1,c2,c3,c4,c5,c6,c7,cf
      include "constants.h"

      ctw2 = mw**2/mz**2
      stw2 = 1-ctw2
      gfermi = pi*alpha/sqrt(2d0)/stw2/mw**2
      xt = sqrt(2d0)*gfermi*mtp**2/16/pi**2

*     M. Faisst et al., hep-ph/0302275      
*     Eq.(19), p.9
      c1 = 157.295d0
      c2 = 112d0
      c3 = -24.73d0
      c4 = 7.39d0
      c5 = -3.52d0
      c6 = 2.06d0
      dht = mh/mtp-1
      
      drho_at2_as1 = 1d0/pi*(
     &     c1 + c2*dht + c3*dht**2 + c4*dht**3 + c5*dht**4 + c6*dht**5
     &                    )

c$$$*     J.J. van der Bij et al., hep-ph/0011373      
c$$$*     Eq.(10), p.7
c$$$      c1  = 185d0/3
c$$$      c2  = 729d0/4
c$$$      c3  = -48d0
c$$$      c4  = -151d0/6
c$$$      c5  = 29d0
c$$$      c6  = -24d0
c$$$      c7  = 12d0
c$$$      cf  = 4d0/3
c$$$      
c$$$      drho_at2_as1 = cf/pi*(
c$$$     &     c1 + c2*s2 + c3*z2*ln2 + c4*z2 + c5*z3 + c6*z4 + c7*b4
c$$$     &                      )
*     drho_at2_as1*pi*nc = 2.9394 ! paper
*     drho_at2_as1*pi*nc = 2.9395 ! real life 
*      print *, drho_at2_as1*pi*3
      
      drho_at2_as1 = 3*xt**2*alphas*drho_at2_as1

      return
      end
