#ifndef EVENT_H
#define EVENT_H

#include "Vec4.h"
#include <vector>

namespace SANC {

class Particle {
public:
  Particle(int id = 0, double spin = 9., int col1 = 0, int col2 = 0)
      : id(id), spin(spin), col1(col1), col2(col2) {}
  int id;
  double spin;
  int col1, col2;
  Vec4 p;
};

class Event {
public:
  double weight() const { return weightProc; }
  Vec4 &P(int part) { return particles[part].p; }
  double &spin(int part) { return particles[part].spin; }
  double weightProc;
  std::vector<Particle> particles;
};
} // namespace SANC

#endif // EVENT_H
