      DOUBLE PRECISION FUNCTION S12(X)
*     ====== ========= ======== ======
C Tsuyoshi Matsuura 1987
C
C     S1,2   between 0 and 1  !!!
C
      REAL*8 X,S(0:10),L(0:20),U,Z,HELP,Z3
      REAL*8 DDILOG
C
C     S: COEFFICIENTS OF S1,2
C     L: COEFFICIENTS OF Li3
C
      DATA S/0.5000000000000000D+00,2.0833333333333333D-02,
     1      -2.3148148148148148D-04,4.1335978835978837D-06,
     2      -8.2671957671957673D-08,1.7397297489890083D-09,
     3      -3.7744215276339238D-11,8.3640853316779243D-13,
     4      -1.8831557201792127D-14,4.2930310281389223D-16,
     5      -9.8857668116275541D-18/
      DATA L/1.0000000000000000D+00,-0.3750000000000000D+00,
     1       7.8703703703703705E-02,-8.6805555555555557E-03,
     2       1.2962962962962963E-04, 8.1018518518518520E-05,
     3      -3.4193571608537598E-06,-1.3286564625850340E-06,
     4       8.6608717561098512E-08, 2.5260875955320400E-08,
     5      -2.1446944683640648E-09,-5.1401106220129790E-10,
     6       5.2495821146008296E-11, 1.0887754406636318E-11,
     7      -1.2779396094493696E-12,-2.3698241773087452E-13,
     8       3.1043578879654624E-14, 5.2617586299125060E-15,
     9      -7.5384795499492655E-16,-1.1862322577752285E-16,
     1       1.8316979965491384E-17/
      DATA Z3/1.2020569031595943D+00/
C
      IF(X .LT. 0D0  .OR.  X .GT. 1D0) THEN
         WRITE(*,*)' **************************************'
         WRITE(*,*)' S12 called with X = ',X
         WRITE(*,*)' This should lie between 0 and 1 !!!'
         STOP' The program stops right here !!!'
      ENDIF
      IF (X.LT.0.5D0) THEN
         IF (X.GT.0.0D0) THEN
            U=-DLOG(1.0D0-X)
            Z=U*U
            HELP=Z*S(10)+S(9)
            DO 10 I=8,0,-1
               HELP=HELP*Z+S(I)
   10       CONTINUE
            S12=1.0D0/2.0D0*(Z*HELP-Z*U/6.0D0)
         ELSE
            S12=0.0D0
         ENDIF
      ELSE
         IF (X.LT.1.0D0) THEN
            U=-DLOG(X)
            HELP=U*L(20)+L(19)
            DO 20 I=18,0,-1
               HELP=HELP*U+L(I)
   20       CONTINUE
            HELP=U*HELP
            S12=-HELP+DLOG(1.0D0-X)*DDILOG(1.0D0-X)+
     +           0.5D0*DLOG(X)*DLOG(1.0D0-X)**2+Z3
         ELSE
            S12=Z3
         ENDIF
      ENDIF
      END

C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION DDD(ILLA,ILPR,ALME,ALD)
C     -------------------------------------------------
C.... ELECTRON STRUCTURE FUNCTION (DELTA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      COMMON /PHCNS/ ALPHA
      ALL1 = ALME - 1D0
CAC
C     PRINT *,'IN DDD',ALME,ALD,ILLA,ILPR
C     PRINT *,'IN DDD,1D0/ALPHA=',1D0/ALPHA
CAC
      DDD = 1D0
      IF(ILLA.EQ.1) DDD = ALPHA/2D0/PI*ALL1*P10(ALD)
      IF(ILLA.EQ.2) DDD = 0.5D0*(ALPHA/2D0/PI*ALL1)**2*P20(ALD)
      IF(ILLA.EQ.3) DDD = 1D0/6D0*(ALPHA/2D0/PI*ALL1)**3*P30(ALD)
      IF(ILLA.EQ.23)DDD = 0.5D0*(ALPHA/2D0/PI*ALL1)**2*P20(ALD)
     &                  + 1D0/6D0*(ALPHA/2D0/PI*ALL1)**3*P30(ALD)

C...  PAIR CONTRIBUTIONS ARE ADDED IF REQUESTED:
      IF(ILLA.EQ.2.AND.ILPR.GE.1) DDD = DDD
     & + 1D0/3D0*(ALPHA/2D0/PI*ALL1)**2*P10(ALD)
      IF(ILLA.EQ.3.AND.ILPR.GE.1) DDD = DDD
     & + (ALPHA/2D0/PI*ALL1)**3*( P20(ALD)/3D0
     &   + 4D0/27D0*P10(ALD) )
      IF(ILLA.EQ.23.AND.ILPR.GE.1) DDD = DDD
     & + 1D0/3D0*(ALPHA/2D0/PI*ALL1)**2*P10(ALD)
     & + (ALPHA/2D0/PI*ALL1)**3*( P20(ALD)/3D0
     &   + 4D0/27D0*P10(ALD) )
CAC
C     PRINT *,'DDD=',DDD,ALPHA/2D0/PI*ALL1*P10(ALD),P10(ALD)
CAC
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION DDT(ILLA,ILPR,ALME,Z)
C     -----------------------------------------------
C.... ELECTRON STRUCTURE FUNCTION (THETA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      COMMON /PHCNS/ ALPHA
      DDT  = 0D0
      ALL1 = ALME - 1D0

      IF(ILLA.EQ.1) DDT = ALPHA/2D0/PI*ALL1*P1(Z)
      IF(ILLA.EQ.2) DDT = 0.5D0*(ALPHA/2D0/PI*ALL1)**2*P2(Z)
c     PRINT *,'1 DDT=',DDT
      IF(ILLA.EQ.3) DDT = 1D0/6D0*(ALPHA/2D0/PI*ALL1)**3*P3(Z)
c     PRINT *,'2 DDT=',DDT
      IF(ILLA.EQ.23)DDT = 0.5D0*(ALPHA/2D0/PI*ALL1)**2*P2(Z)
     &                  + 1D0/6D0*(ALPHA/2D0/PI*ALL1)**3*P3(Z)
c     PRINT *,'3 DDT=',DDT

C...  PAIR CONTRIBUTIONS ARE ADDED IF REQUESTED:
      IF(ILLA.EQ.2.AND.ILPR.GE.1) DDT = DDT
     &     + 1D0/3D0*(ALPHA/2D0/PI*ALL1)**2*P1(Z)
      IF(ILLA.EQ.23.AND.ILPR.GE.1) DDT = DDT
     &     + 1D0/3D0*(ALPHA/2D0/PI*ALL1)**2*P1(Z)
c     PRINT *,'4 DDT=',DDT
      IF(ILLA.EQ.2.AND.ILPR.EQ.2) DDT = DDT
     &     + 0.5D0*(ALPHA/2D0/PI*ALL1)**2*RS(Z)
      IF(ILLA.EQ.23.AND.ILPR.EQ.2) DDT = DDT
     &     + 0.5D0*(ALPHA/2D0/PI*ALL1)**2*RS(Z)
      IF(ILLA.EQ.3.AND.ILPR.GE.1) DDT = DDT 
     & + (ALPHA/2D0/PI*ALL1)**3*( P2(Z)/3D0 + 4D0/27D0*P1(Z) )
      IF(ILLA.EQ.23.AND.ILPR.GE.1) DDT = DDT 
     & + (ALPHA/2D0/PI*ALL1)**3*( P2(Z)/3D0 + 4D0/27D0*P1(Z) )
      IF(ILLA.EQ.3.AND.ILPR.EQ.2) DDT = DDT 
     & + (ALPHA/2D0/PI*ALL1)**3*( RP(Z)/3D0 - RS(Z)/9D0 )
      IF(ILLA.EQ.23.AND.ILPR.EQ.2) DDT = DDT 
     & + (ALPHA/2D0/PI*ALL1)**3*( RP(Z)/3D0 - RS(Z)/9D0 )
c     PRINT *,'5 DDT=',DDT
CAC
c     PRINT *,'DDT=',DDT,(ALPHA/2D0/PI*ALL1)**3*P3(Z)/6D0
c     PRINT *,'DDT=',DDT,0.5D0*(ALPHA/2D0/PI*ALL1)**2*P2(Z),illa,ilpr
c     PRINT *,'DDT=',DDT,(ALPHA/2D0/PI*ALL1)*P1(Z),illa,ilpr
CAC

      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION P10(ALD)
C     ----------------------------------
C.... P1 SPLITTING FUNCTION (DELTA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      P10  = 3D0/2D0 + 2D0*ALD
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION P1(Z)
C     -------------------------------
C.... P1 SPLITTING FUNCTION (THETA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      P1   = (1D0+Z**2)/(1D0-Z)
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION P20(ALD)
C     ----------------------------------
C.... P2 SPLITTING FUNCTION (DELTA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      PI = 4D0*DATAN(1D0)
      DZ2= PI**2/6D0
      DZ3 = 1.20205690315959D0

      P20  = ( 3D0/2D0 + 2D0*ALD )**2 - 4D0*DZ2
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION P2(Z)
C     -------------------------------
C.... P2 SPLITTING FUNCTION (THETA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      P2   = 2D0*( (1D0+Z**2)/(1D0-Z)*( 2D0*DLOG(1D0-Z)
     &     - DLOG(Z) + 3D0/2D0 ) + (1D0+Z)/2D0*DLOG(Z)
     &     - 1D0 + Z )
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION P30(ALD)
C     ----------------------------------
C.... P3 SPLITTING FUNCTION (DELTA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      PI = 4D0*DATAN(1D0)
      DZ2= PI**2/6D0
      DZ3 = 1.20205690315959D0

      P30  = 48D0
     &    * ( DZ3/3D0 - DZ2/2D0*(ALD+3D0/4D0)
     &    + 1D0/6D0*(ALD+3D0/4D0)**3 )
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION P3(Z)
C     -------------------------------
C.... P3 SPLITTING FUNCTION (THETA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      PI = 4D0*DATAN(1D0)
      DZ2= PI**2/6D0
      DZ3 = 1.20205690315959D0

      DLZ  = DLOG(Z)
      DL1Z = DLOG(1D0-Z)
      P3   = 48D0
     &     * ( 0.5D0*(1D0+Z**2)/(1D0-Z)*( 9D0/32D0 - PI**2/12D0
     &     + 3D0/4D0*DL1Z - 3D0/8D0*DLZ + 0.5D0*DL1Z**2
     &     + 1D0/12D0*DLZ**2 - 0.5D0*DLZ*DL1Z )
     &     + 1D0/8D0*(1D0+Z)*DLZ*DL1Z
     &     - 1D0/4D0*(1D0-Z)*DL1Z + (5D0-3D0*Z)/32D0*DLZ
     &     - (1D0-Z)/16D0 - (1D0+Z)/32D0*DLZ**2
     &     + (1D0+Z)/8D0*SPENCE(1D0-Z) )
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION P40(ALD)
C     ----------------------------------
C.... P4 SPLITTING FUNCTION (DELTA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      PI = 4D0*DATAN(1D0)
      DZ2= PI**2/6D0
      DZ3 = 1.20205690315959D0

      DZ4  = PI**4/90D0
      P40  = 16D0*(ALD+3D0/4D0)**4 - 96D0*DZ2*(ALD+3D0/4D0)**2
     & + 128D0*DZ3*(ALD+3D0/4D0) + 24D0*DZ4 
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION P4(Z)
C     -------------------------------
C.... P4 SPLITTING FUNCTION (THETA-PART)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      PI = 4D0*DATAN(1D0)
      DZ2= PI**2/6D0
      DZ3 = 1.20205690315959D0

      DLZ  = DLOG(Z)
      DL1Z = DLOG(1D0-Z)
      P4   = 144D0 * (
     & + (1D0+Z**2)/(1D0-Z)*( 2D0/9D0*DL1Z**3 + DL1Z**2/2D0
     &   + (3D0/8D0 - 2D0/3D0*DZ2)*DL1Z - 1D0/3D0*DL1Z**2*DLZ
     &   + 1D0/9D0*DL1Z*DLZ**2 - 0.5D0*DL1Z*DLZ - DLZ**3/108D0
     &   + DLZ**2/12D0 + (DZ2/3D0 - 3D0/16D0)*DLZ
     &   - 1D0/9D0*DLZ*SPENCE(1D0-Z) - 2D0/9D0*S12(1D0-Z)
     &   + 3D0/32D0 - DZ2/2D0 + 4D0/9D0*DZ3 )
     & - (1D0-Z)/3D0*DL1Z**2 - (1D0-Z)/6D0*DL1Z
     & + (1D0+Z)/6D0*DL1Z**2*DLZ - (1D0+Z)/12D0*DL1Z*DLZ**2 
     & + (5D0-3D0*Z)/12D0*DL1Z*DLZ + 7D0*(1D0+Z)/864D0*DLZ**3
     & + (5D0*Z-11D0)/144D0*DLZ**2
     & + ( (43D0-5D0*Z)/288D0 - (1D0+Z)/6D0*DZ2 )*DLZ
     & + (1D0+Z)/3D0*DL1Z*SPENCE(1D0-Z) - (1D0+Z)/3D0*TRILOG(1D0-Z)
     & + (1D0+Z)/6D0*S12(1D0-Z) + (1D0+Z)/12D0*SPENCE(1D0-Z)
     & - 11D0*(1D0-Z)/144D0 + (1D0-Z)/3D0*DZ2 ) 
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION RS(Z)
C     -------------------------------
C.... SINGLET SPLITTING FUNCTION 
      IMPLICIT REAL*8(A-H,O-Z)
      RS   = (1D0-Z)/3D0/Z*( 4D0 + 7D0*Z + 4D0*Z**2 )
     &     + 2D0*(1D0+Z)*DLOG(Z)
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION RP(Z)
C     -------------------------------
C.... SINGLET SPLITTING FUNCTION (RS*P1)
      IMPLICIT REAL*8(A-H,O-Z)
      RP   = ( 3D0/2D0 + 2D0*DLOG(1D0-Z) )*RS(Z)
     & + (1D0+Z)*( - DLOG(Z)**2 + 4D0*SPENCE(1D0-Z) )
     & + 1D0/3D0*( - 9D0 - 3D0*Z + 8D0*Z**2 )*DLOG(Z)
     & + 2D0/3D0*( - 3D0/Z - 8D0 + 8D0*Z + 3D0*Z**2 )
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION PEE1G(Z)
C     ----------------------------------
C.... NLO SPLITTING FUNCTION P_{ee}^{(1,\gamma)} time-like
C.... A.A. & K.Melnikov 2002, Eqs.(15-18)      
      IMPLICIT REAL*8(A-H,O-Z)
      PEE1G = (1D0+Z**2)/(1D0-Z)*( 2D0*DLOG(Z)*DLOG(1D0-Z)
     & - 2D0*DLOG(Z)**2 - 2D0*SPENCE(1D0-Z) )
     & + (1D0+Z)/2D0*DLOG(Z)**2 + 2D0*Z*DLOG(Z) - 3D0*Z + 2D0
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION PEE1PNS(Z)
C     ------------------------------------
C.... NLO SPLITTING FUNCTION P_{ee}^{(1,NS pair)} time-like
C.... A.A. & K.Melnikov 2002, Eqs.(15-18)      
      IMPLICIT REAL*8(A-H,O-Z)
      PEE1PNS = - 20D0/9D0/(1D0-Z) - 2D0/3D0*(1D0+Z**2)/(1D0-Z)*DLOG(Z)
     & - 2D0/9D0 + 22D0/9D0*Z 
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION PEE1PS(Z)
C     -----------------------------------
C.... NLO SPLITTING FUNCTION P_{ee}^{(1,S pair)} time-like
C.... A.A. & K.Melnikov 2002, Eqs.(15-18)      
      IMPLICIT REAL*8(A-H,O-Z)
      PEE1PS = (1D0+Z)*DLOG(Z)**2
     & - ( 5D0 + 9D0*Z - 8D0/3D0*Z**2 )*DLOG(Z)
     & - 8D0 - 20D0/9D0/Z + 4D0*Z + 56D0/9D0*Z**2 
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION PEE1PINT(Z)
C     -------------------------------------
C.... NLO SPLITTING FUNCTION P_{ee}^{(1,INT pair)} time-like
C.... A.A. & K.Melnikov 2002, Eqs.(15-18)      
      IMPLICIT REAL*8(A-H,O-Z)
      PEE1PINT = (1D0+Z**2)/(1D0-Z)*( 2D0*SPENCE(1D0-Z)
     & + 3D0/2D0*DLOG(Z) ) - 7D0/2D0*(1D0+Z)*DLOG(Z) - 7D0 + 8D0*Z
      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION P0P1G(Z)
C     ----------------------------------
C.... NLO SPLITTING FUNCTION P_{ee}^{(0)}\otimes P_{ee}^{(1,gamma)} time-like?
C.... ???      
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      COMMON /PARAM/ EPS,REP1,RAP1
C.... PARAMETERS:
      EPS    = 1D-12
      REPS   = 1D-6
      RAPS   = REPS*REPS
      REP1   = REPS/10D0
      RAP1   = REP1*REP1
      
      G =(1D0+Z**2)/(1D0-Z)
      S12Z = S12(1D0-Z)
      SP1Z = SPENCE(1D0-Z)
      DLZ  = DLOG(Z)
      DL1Z = DLOG(1D0-Z)
      
      P0P1G = G * ( 3./8. - 4*S12Z - 3*DLZ*DL1Z - 4*DLZ*DL1Z**2 
     & + 3./2.*DLZ**2 + 4*DLZ**2*DL1Z - 2./3.*DLZ**3 + 3*SP1Z 
     & + 4*SP1Z*DL1Z - 4*SP1Z*DLZ + 6*DZ3 - 3*DZ2 + 4*DZ2*DLZ )
     & - 1./2. + 4*S12Z + 6*DL1Z - 3*DLZ + 6*DLZ*DL1Z 
     & - 9./4.*DLZ**2 - 2*DLZ**2*DL1Z + 1./2.*DLZ**3 - 2*SP1Z + 2*z 
     & + 4*z*S12Z - 4*z*DL1Z + 5*z*DLZ - 2*z*DLZ*DL1Z
     & + 11./4.*z*DLZ**2 - 2*z*DLZ**2*DL1Z + 1./2.*z*DLZ**3 + 6*z*SP1Z

      RETURN
      END
C----------------------------------------------------------------------- 
      DOUBLE PRECISION FUNCTION P0P0D1(Z)
C     -----------------------------------
C.... NLO SPLITTING FUNCTION P_{ee}^{(0)}\otimes P_{ee}^{(0)}\otimes d1
C      time-like?
C.... ???      
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /CONST/ PI,DZ2,DZ3
      COMMON /PARAM/ EPS,REP1,RAP1
C.... PARAMETERS:
      EPS    = 1D-12
      REPS   = 1D-6
      RAPS   = REPS*REPS
      REP1   = REPS/10D0
      RAP1   = REP1*REP1
      
      G =(1D0+Z**2)/(1D0-Z)
      S12Z = S12(1D0-Z)
      SP1Z = SPENCE(1D0-Z)
      TRIZ = TRILOG(1D0-Z)
      DLZ  = DLOG(Z)
      DL1Z = DLOG(1D0-Z)
      
      P0P0D1 = G * ( 15./4. + 16*S12Z - 17./2.*DL1Z - 30D0*DL1Z**2
     & - 16*DL1Z**3 + 2*DLZ + 24*DLZ*DL1Z + 20*DLZ*DL1Z**2 - 2*DLZ**2
     & - 4*DLZ**2*DL1Z + 8*SP1Z*DLZ - 32*DZ3 + 24*DZ2 + 40*DZ2*DL1Z 
     & - 16*DZ2*DLZ )
     & - 2D0 + 20*TRIZ - 10*S12Z + 4*DL1Z + 20*DL1Z**2
     & - 2*DLZ - 18*DLZ*DL1Z - 10*DLZ*DL1Z**2 + 3./2.*DLZ**2 
     & + 3*DLZ**2*DL1Z - 2*SP1Z - 20*SP1Z*DL1Z - 2*SP1Z*DLZ - 16*DZ2 
     & + 8*DZ2*DLZ + 2*z + 20*z*TRIZ - 10*z*S12Z - 4*z*DL1Z
     &  - 20*z*DL1Z**2 + 14*z*DLZ*DL1Z - 10*z*DLZ*DL1Z**2
     & - 3./2.*z*DLZ**2 + 3*z*DLZ**2*DL1Z - 2*z*SP1Z - 20*z*SP1Z*DL1Z
     & - 2*z*SP1Z*DLZ + 16*z*DZ2 + 8*z*DZ2*DLZ

      
      RETURN
      END
C----------------------------------------------------------------------- 
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION S12L(Y)
C     ---------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /PARAM/ EPS,REP1,RAP1
      EXTERNAL FUN12

      XN     = EPS
      XX     = Y
      XST    = 0.0025D0*(XX-XN)
      CALL SIMPU(XN,XX,XST,REP1,RAP1,FUN12,TT,RES,RES2,RES3)

      S12L = RES
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION S13(Y)
C     --------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /PARAM/ EPS,REP1,RAP1
      EXTERNAL FUN13

      XN     = EPS
      XX     = Y
      XST    = 0.0025D0*(XX-XN)
      CALL SIMPU(XN,XX,XST,REP1,RAP1,FUN13,TT,RET,RES2,RES3)
      S13    = - RET/6D0
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION S22(Y)
C     --------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /PARAM/ EPS,REP1,RAP1
      COMMON /VARY / YY
      EXTERNAL FUN22
      YY     = Y
      XN     = EPS
      XX     = 1D0 - EPS
      XST    = 0.0025D0*(XX-XN)
      CALL SIMPU(XN,XX,XST,REP1,RAP1,FUN22,TT,RET,RES2,RES3)
      S22    = - RET/2D0
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION S31(Y)
C     --------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /PARAM/ EPS,REP1,RAP1
      COMMON /VARY / YY
      EXTERNAL FUN31
      YY     = Y
      XN     = EPS
      XX     = 1D0 - EPS
      XST    = 0.0025D0*(XX-XN)
      CALL SIMPU(XN,XX,XST,REP1,RAP1,FUN31,TT,RET,RES2,RES3)
      S31    = - RET/2D0
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FUNT(X)
C     ---------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      FUNT = 1D0
      IF(X.NE.0D0) FUNT = SPENCE(X)/X
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FUN12(X)
C     ---------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /PARAM/ EPS,REP1,RAP1
      FUN12 = 0D0
      IF(X.NE.0D0) FUN12 = DLOG(DABS(1D0-X)+EPS)**2/X/2D0
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FUN13(X)
C     ---------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      FUN13 = 0D0
      IF(X.LT.1D0) FUN13 = DLOG(1D0-X)**3/X
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FUN22(X)
C     ---------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /VARY / YY
      FUN22 = 0D0
      IF(X.GT.0D0.AND.X.LT.1D0) FUN22 = DLOG(1D0-X*YY)**2*DLOG(X)/X
      RETURN
      END
C----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FUN31(X)
C     ---------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /VARY / YY
      FUN31 = 0D0
      IF(X.GT.0D0.AND.X.LT.1D0) FUN31 = DLOG(1D0-X*YY)*DLOG(X)**2/X
      RETURN
      END
C----------------------------------------------------------------------
C----------------------------------------------------------------------
      
