************************************************************************
* sanc_nc_v1.30 package.
************************************************************************
* File (nc_si_12_12__02_04.f) is created on Wed Apr 18 13:47:39 MSK 2012.
************************************************************************
* This is the FORTRAN module (nc_si_12_12__02_04) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the el^+ + el^- -> Z + H process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_si_12_12__02_04 (s,t,u,sigma)
      implicit none!
      include 's2n_declare.h'

      integer iz,i,j,k,l,is,jj,izi
      real*8 sum,tw(2),sig(2)
      real*8 deltar,dr_bos,dr_fer
      real*8 kappa,cof,nsig,twcoeff,twl,coeff,slams
      complex*16 zoro
      complex*16 ffgp0,ffgp1,ffgp2,ffgm0,ffgm1,ffgm2
      complex*16 ff_gp0,ff_gp1,ff_gp2,ff_gm0,ff_gm1,ff_gm2

      real*8 sqrtls12,sqrtls34
      real*8 betai

      complex*16 amp(2,2,3)
      real*8 amp2_(2,2,2),amp2(2,2)
      real*8 costhz,sinthz
      complex*16 propzs,propizs,propzsc
      real*8 mel_tmp

      izi = 0
      if (ilin.eq.0) then
         twl = 0d0
      elseif (ilin.eq.1) then
         twl = 1d0
      endif

      cmz2 = mz2
      spr = s
      qs = -s
      ts = -t
      us = -u

      betai = sqrt(1d0-4*mel**2/s);
      betaf = sqrt((s-(mh+mz)**2)*(s-(mh-mz)**2))/s;

      sqrtls12 = sqrt(s**2-4d0*s*mel**2)
      sqrtls34 = sqrt(s**2-2d0*s*(rzm2+rhm2)+(rzm2-rhm2)**2)
      cosf = (u-t)/s/betai/betaf
      if (abs(cosf).gt.1d0) cosf = sign(1d0,cosf)
      sinf = dsqrt(1d0-cosf**2)
      if (irun.eq.0) then
         propizs = (cmz2-s)
      else
         propizs = (dcmplx(mz**2,-s*wz/mz)-s)
      endif
      propzs = 1d0/propizs
      propzsc = dconjg(propzs)
      costhz = cosf
      sinthz = sinf
!     d(sigma)=R_2/j*M^2
!     j=2*sqrtlsee
!     R_2=1/(4*pi^2)*sqrtls34/(8*s)d(Omega)
!     According SANC agreement, modules return value integrated over phi3. So
!     R_2=1/(4*pi^2)*sqrtls34/(8*s)*2*pi*d(costh3)
!     1/4 from averaging over initial helicities appears in polarization section
!     nsig=1/(4*pi**2)*sqrtls34/(8*s)*2*pi/(2*sqrtls12)*conhc
!     nsig=conhc*sqrtls34/sqrtls12/s/pi/32d0
      nsig=conhc*sqrtls34/sqrtls12/s/pi/32d0
      if ((iborn.eq.1).or.(iew.eq.0)) then
         ff_gp0 = dcmplx(0d0,0d0)
         ff_gp1 = dcmplx(0d0,0d0)
         ff_gp2 = dcmplx(0d0,0d0)
         ff_gm0 = dcmplx(0d0,0d0)
         ff_gm1 = dcmplx(0d0,0d0)
         ff_gm2 = dcmplx(0d0,0d0)
      else
         coeff = cfprime*alpha/4d0/pi/stw2
         call delr(deltar,dr_bos,dr_fer)
         deltar = coeff*deltar
         call UniBosConsts_Bos ()
         call UniBosConsts_Fer ()
         call UniProConsts_Fer (-s)
         call nc_ff_12_12__02_04 (-s,-t,-u)

         ff_gp0 = coeff*ffarray(1,1)
         ff_gp1 = coeff*ffarray(1,2)
         ff_gp2 = coeff*ffarray(1,3)
         ff_gm0 = coeff*ffarray(1,4)
         ff_gm1 = coeff*ffarray(1,5)
         ff_gm2 = coeff*ffarray(1,6)

         if ((gfscheme.ge.1).and.(gfscheme.le.3)) then
            ff_gp0 = ff_gp0-deltar
            ff_gm0 = ff_gm0-deltar
         endif
         if (gfscheme.eq.4) then
            ff_gp0 = ff_gp0-deltaa
            ff_gm0 = ff_gm0-deltaa
         endif
      endif

      do iz = izi,1
         zoro = dcmplx(iz,0d0)
         ffgp0 = zoro + ff_gp0
         ffgp1 =        ff_gp1
         ffgp2 =        ff_gp2
         ffgm0 = zoro + ff_gm0
         ffgm1 =        ff_gm1
         ffgm2 =        ff_gm2
         if (iz.eq.1) then
            ffarray(2,1) = ffgp0
            ffarray(2,2) = ffgp1
            ffarray(2,3) = ffgp2
            ffarray(2,4) = ffgm0
            ffarray(2,5) = ffgm1
            ffarray(2,6) = ffgm2
         endif

      amp(1,1,1) =
     & 0d0

      amp(1,1,3) =
     & 0d0

      amp(1,1,2) =
     & 0d0

      amp(1,2,1) =
     & ((-1+costhz)*g**2*mz*propzs*sqrt(s)*(4*ffgp0*vpael-(1+costhz)*(ffgp1-ffgp2)*sqrtls34))/(8.*ctw**2*sr2)

      amp(1,2,3) =
     & -(g**2*propzs*sinthz*(4*ffgp0*(-rhm2+rzm2+s)*vpael+sqrtls34*(
     & (rhm2-rzm2-s)*costhz*(ffgp1-ffgp2)+(ffgp1+ffgp2)*sqrtls34)))/(16.*ctw**2)

      amp(1,2,2) =
     & ((1+costhz)*g**2*mz*propzs*sqrt(s)*(-4*ffgp0*vpael+(-1+costhz)*(ffgp1-ffgp2)*sqrtls34))/(8.*ctw**2*sr2)

      amp(2,1,1) =
     & ((1+costhz)*g**2*mz*propzs*sqrt(s)*(4*ffgm0*vmael-(-1+costhz)*(ffgm1-ffgm2)*sqrtls34))/(8.*ctw**2*sr2)

      amp(2,1,3) =
     & -(g**2*propzs*sinthz*(4*ffgm0*(-rhm2+rzm2+s)*vmael+sqrtls34*(
     & (rhm2-rzm2-s)*costhz*(ffgm1-ffgm2)+(ffgm1+ffgm2)*sqrtls34)))/(16.*ctw**2)

      amp(2,1,2) =
     & ((-1+costhz)*g**2*mz*propzs*sqrt(s)*(-4*ffgm0*vmael+(1+costhz)*(ffgm1-ffgm2)*sqrtls34))/(8.*ctw**2*sr2)

      amp(2,2,1) =
     & 0d0

      amp(2,2,3) =
     & 0d0

      amp(2,2,2) =
     & 0d0

         do i=1,2
            do j=1,2
               sum = 0d0
               do k=1,3
                  sum = sum + amp(i,j,k)*conjg(amp(i,j,k))
               enddo
               amp2_(iz+1,i,j) = sum
            enddo
         enddo
      enddo

      do i = 1,2
         do j = 1,2
            amp2(i,j) = amp2_(2,i,j)-twl*amp2_(1,i,j)
         enddo
      enddo

      if (alr.eq.0) then
         sigma =
     &       (+(1+lamep)*(1+lamem)*amp2(1,1)
     &        +(1+lamep)*(1-lamem)*amp2(1,2)
     &        +(1-lamep)*(1+lamem)*amp2(2,1)
     &        +(1-lamep)*(1-lamem)*amp2(2,2))/4d0
      elseif (alr.eq.1) then
         sigma =
     &        +(amp2(1,2)-amp2(2,1))
      elseif (alr.eq.2) then
         sigma =
     &        +(amp2(1,2)+amp2(2,1))
      elseif (alr.eq.3) then
         sigma =
     &        +(amp2(1,2)+amp2(2,2)-amp2(1,1)-amp2(2,1))/2d0
      elseif (alr.eq.4) then
         sigma =
     &        +(amp2(1,2)+amp2(2,2)+amp2(1,1)+amp2(2,1))/2d0
      endif

      sigma = nsig*sigma
      if (sigma.ne.sigma) print *,'Sigma NAN!!!',s,t,u

      return
      end
