#include "DataSaver.h"
#include "Info.h"
#include "Process.h"
#include "OutputFormat.h"
#include "OF_LHEF.h"

using namespace SANC;

DataSaver::DataSaver(Info & _info, Process & _proc):info(_info),proc(_proc)
{
    if (info.PrintLHE == 1) {
        writer = new OF_LHEF(info, proc);
    }
}

void DataSaver::setOutput(std::ostream * _output) {
    if (writer) {
        writer->setOutput(_output);
    }    
}

void DataSaver::start() {
    if (writer) {
        writer->start();
    }
}

void DataSaver::writeEvent() {
    if (writer) {
        writer->writeEvent();
    }
}