# This module tries to find the HepMC installation on your system.

message(STATUS "Looking for HepMC")

set(HEPMC_FOUND 0)

# try to find LHAPDF in user defined path
find_library(HEPMC_LIBRARY
    NAMES
        libHepMC.so HepMC libHepMC.a libHepMC.la
    PATH_SUFFIXES
        lib lib64
    PATHS
        $ENV{HEPMC_ROOT}
        $ENV{HEPMC_DIR}
        ${HEPMC_DIR}
        /opt/HepMC
        /usr/local
        /usr
        ~/local
        ~/local/HepMC
    DOC "Specify the HepMC library here."
)

IF(NOT ${HEPMC_LIBRARY} MATCHES "HEPMC_LIBRARY-NOTFOUND")
    FIND_PATH(HEPMC_INCLUDE
        HepMC/Version.h
	    PATHS
            $ENV{HEPMC_ROOT}/include
            $ENV{HEPMC_DIR}/include
            ${HEPMC_DIR}/include
	        /usr/include
	        /usr/local/include
            ~/local/include
            ~/local/HepMC/include
	)
ENDIF(NOT ${HEPMC_LIBRARY} MATCHES "HEPMC_LIBRARY-NOTFOUND")

# final printout.
IF((${HEPMC_LIBRARY} MATCHES "HEPMC_LIBRARY-NOTFOUND") OR (${HEPMC_INCLUDE} MATCHES "HEPMC_INCLUDE-NOTFOUND"))
    set(HEPMC_LIBRARY "" CACHE FILEPATH "" FORCE)
    set(HEPMC_FOUND 0 )
ELSE((${HEPMC_LIBRARY} MATCHES "HEPMC_LIBRARY-NOTFOUND") OR (${HEPMC_INCLUDE} MATCHES "HEPMC_INCLUDE-NOTFOUND"))
    message(STATUS "Looking for HepMC... - found " ${HEPMC_LIBRARY} )
    message(STATUS "Looking for HepMC... - found " ${HEPMC_INCLUDE} )
    set(HEPMC_FOUND 1 )
#	include_directories(${HEPMC_INCLUDE})
ENDIF((${HEPMC_LIBRARY} MATCHES "HEPMC_LIBRARY-NOTFOUND") OR (${HEPMC_INCLUDE} MATCHES "HEPMC_INCLUDE-NOTFOUND"))
